package game

//something that could be carried and dropped
type Luggage interface {
    Mob
    Drop(carrier Monster) bool
    Pickup(carrier Monster) bool
}

//something that could be used from inventory
type Usable interface {
    GetUsageVariants() //not Use() cause you could do many things with a potion - drink and throw for instance
    Use(variant string)
}
//Item that could be carried and used
type Item interface {
    Luggage
    Usable
}

//something you can wear
type Wearable interface {
    Luggage
    Wear()
    Takeoff()
}
