package game

//see https://stackoverflow.com/questions/32188653/golang-and-inheritance

//something that could be placed on map - MapObject
type Mob interface {
    Drawable
    GetCoords() Coords
    SetCoords(x, y int)
    SetX(x int)
    SetY(y int)
}

//something that must be ai-processed
type Sentient interface {
    SetAi()
    GetAi()
    TakeTurn()
}

//something with inventory
type Monster interface {
    Mob
}

//Something that can fight
type Fighter interface {
    Mob
    Spawn()
    Die()
    Attack()
    Move()
    GetBuffs()
    SetBuffs()
}

