package util

import (
    "reflect"
    "flag"
    "io/ioutil"
    "log"
    "encoding/json"
)

type Config struct {
    Title string `json:"title"`
    FpsLimit int `json:"fpsLimit, omitempty" validate:"required"`
}

func LoadConfig () *Config {
    var configArg string = "./config.json"
    flag.StringVar(&configArg, "cfg", configArg, "config file location")
    flag.Parse()

    // get config
    data, err := ioutil.ReadFile(configArg)
    if err != nil {
        log.Fatalf("Application couldn't read config at %s", configArg)
    }
    config := new(Config)
    err = json.Unmarshal(data, config)
    if err != nil {
        log.Fatalln(err)
    }
    return config
}

func InArray(val interface{}, array interface{}) (exists bool, index int) {
    exists = false
    index = -1

    switch reflect.TypeOf(array).Kind() {
    case reflect.Slice:
        s := reflect.ValueOf(array)

        for i := 0; i < s.Len(); i++ {
            if reflect.DeepEqual(val, s.Index(i).Interface()) == true {
                index = i
                exists = true
                return
            }
        }
    }
    return
}